//----------------------------------------------------------------
// 99
// Oh!X 1990/5 p83-86 より移植
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
int fzenhan
width(96,,fzenhan)
int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2
dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

dim int C1(51),C2(31),PL(19):// PL＝手元にあるカード(プレイヤー5人＊4枚)
dim int YK(51)={ /* 役札内容
/* -A--2--3--4--5--6--7--8--9-10--J--Q--K--
   95, 0, 0,92, 0, 0, 0, 0,93,94,91, 0, 0,	/* スペード
    6, 0, 0,92, 0, 0, 0, 0,93,94,91, 0, 0,	/* ハート
    3, 0, 0,92, 0, 0, 0, 0,93,94,91, 0, 0,	/* ダイヤ
   95, 0, 0,92, 0, 0, 0, 0,93,94,91, 0, 0	/* クラブ
}
dim str NM(4)={"うさぎさん","かめさん","ぶたさん","ねこさん","あなた"}
int PN,PV=1,BA=0,BP,CX=0,YS=0
int snd_pico,snd_ton,snd_para

//----------------------------------------------------------------
// MAIN PROGRAM

if not isLocalizeJapan() then {
	NM={"Rabit"," Bird"," Dog"," Cat"," You"}
}

// 音声データ読み込み
snd_pico=a_setPlayData("99_1.mp3")
snd_ton =a_setPlayData("99_2.mp3")
snd_para=a_setPlayData("99_3.mp3")

INIT()
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
bitmapOpen(0,0,YES)
while 1
	cls():wipe()
	CINIT()
	GAME()
	GOVER()
endwhile

// 音声バッファー開放
a_end(snd_pico)
a_end(snd_ton)
a_end(snd_para)

bitmapClose()
end

//----------------------------------------------------------------

func wtm(n;int)
/* 時間待ち
/* X68 10MHz n=500で42秒
	if n<0 then	{
		wait((42.0/500.0)/(-n))
	} else {
		wait((42.0/500.0)*n)
	}
//	int i
//	for i=0 to n*500:next
endfunc

//----------------------------------------------------------------

func INIT()
	str A,TT="Ninety-Nine"://"Ｎｉｎｅｔｙ－Ｎｉｎｅ"
	str FONTT="Hoefler Text"
	cls()
	
	YS=0
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="役札の解説が必要ですか?"
		menues={"はい","いいえ"}
	} else {
		title$="Do you need a description of the role card?"
		menues={"Yes","No"}
	}
	switch selectMenu2(title$,menues)
		case 0
			YS=1
			break
		case 1
			YS=0
			break
	endswitch

	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	setgPalet16X68(1,&h000000ff)
	
	apage(GPAGE3):wipe()
	gColor16X68( 8):fill(0,0,511,511)
	gColor16X68( 0):symbol(231,9,TT,FONTT,40)
//	symbol(231,9,TT,1,2,2,0 ,0)
	gColor16X68(15):symbol(230,8,TT,FONTT,40)
//	symbol(230,8,TT,1,2,2,15,0)
	gColor16X68(0 ):box(390,141,500,336)
	gColor16X68(15):box(389,140,499,335)
	apage(GPAGE1):wipe()
	int I,K
	for I=0 to 4
		K=I*CARD_WY+16
		gColor16X68(15):symbolt(0,K,NM(I),FONT,FNTSZ)
	next
	apage(GPAGE2):wipe()
	apage(GPAGE0):wipe()
endfunc

//----------------------------------------------------------------

func CINIT()
/* カード初期化
	int I
	for I=0 to 51:C1(I)=I+1:next
	for I=3 to 31:C2(I)=0:next
	for I=0 to 19:PL(I)=0:next
	SFL(52):DEALALL():BAPRT()
	if YS=1 then YSETU()
endfunc

//----------------------------------------------------------------

func SFL(N;int)
/* シャッフル
	int A,B,C,I
	MSG(30,12,localizedString("シャッフル中です","shuffling..."))
	for I=0 to 99
		A=rnd()*N:B=rnd()*N
		C=C1(A):C1(A)=C1(B):C1(B)=C
	next
	MSG(30,12,chr$(DISP_CTRL_CLEARLINE))
endfunc

//----------------------------------------------------------------

func CDPUT(X;int,Y;int,N;int)
/* 1枚カード表示
// 59はクリアカード(描画されないカード)として使っている
	if N=0 then {
		cardPut(X*CARD_WX+16,Y*CARD_WY+8,59,NO)
	} else {
		if N<100 and Y<4 then N=0
		if N>=100 then N=N-100:if N=0 then N=59
		cardPut(X*CARD_WX+16,Y*CARD_WY+8,N,NO)
	}
endfunc

//----------------------------------------------------------------

func DEALALL()
/* 画面にカードを並べる
	int I,X,Y
	for I=0 to 3
		PL(I)   =C1(I+32):C1(I+32)=0:// うさぎさん
		PL(I+4) =C1(I+36):C1(I+36)=0:// かめさん
		PL(I+8) =C1(I+40):C1(I+40)=0:// ぶたさん
		PL(I+12)=C1(I+44):C1(I+44)=0:// ねこさん
		PL(I+16)=C1(I+CARD_WX):C1(I+CARD_WX)=0:// あなた
	next
	for Y=0 to 4:// プレイヤー5人
		for X=0 to 3:// 4枚ずつ
			a_play(snd_ton)
			CDPUT(X,Y,PL(X+Y*4))
		next
	next
	X=rnd()*10+10
	for Y=0 to X
		PN=Y mod 5:NM_MARK(PN)
		wtm(-8)
	next
endfunc

//----------------------------------------------------------------

func Y_TEST(N;int)
/* 役札のチェック
	int A,B
	A=YK(N-1)/10*10:B=YK(N-1) mod 10
	if A>BA then return(0) else return(B)
endfunc

//----------------------------------------------------------------

func NM_MARK(N;int)
/* 名前のマーク表示
	apage(GPAGE2)
	gColor16X68(0):fill(0,0,14,511)
	gColor16X68(4):fill(0,N*CARD_WY+11,14,N*CARD_WY+100)
	apage(GPAGE0)
endfunc

//----------------------------------------------------------------

func CD_SEL()
/* カード選択(人間用)
	int A,X
	int Y=4:// 人間のカードの位置
	
	// タッチ座標設定
	A=0
	for X=0 to 3
		touchNo(inc(A))=setTouchArea(X*CARD_WX+16,Y*CARD_WY+8,CARD_WX,CARD_WY,X+1,YES,0,0,0,0)
	next
	touchallcnt=X

	// 前のカード位置
//	gColor16X68(6):fill(CX*CARD_WX+16,490,CX*CARD_WX+64,493)

	// カード選択
	repeat:X=inkey():until X<>0
	X=X-1:// キーコードとして＋1されているので
	//
	gColor16X68(0):fill(0*CARD_WX+16,490,3*CARD_WX+64,493):// 全体をクリア
	gColor16X68(6):fill(X*CARD_WX+16,490,X*CARD_WX+64,493):// 今回選択したカードを示す
	wait(1):// ちょっと表示して消す
	removeKeys():// その待ちの間にタッチキーエリアも解除する
	gColor16X68(0):fill(0*CARD_WX+16,490,3*CARD_WX+64,493):// 全体をクリア
	CX=X
	return(X)
endfunc

//----------------------------------------------------------------

func PL_SEL()
/* プレイヤー指名(キー入力部)
	int A,Y
	MSG(28,12,localizedString("プレイヤーをタッチで選択してください","Please select player with touch.") )

	// タッチ座標設定
	A=0
	for Y=0 to 4
		touchNo(inc(A))=setTouchArea(0*CARD_WX+16,Y*CARD_WY+8,48*4,96,Y+1,YES,0,0,0,0)
	next
	touchallcnt=Y

	// 選択
	repeat:Y=inkey():until Y<>0
	Y=Y-1:// キーコードとして＋1されているので
	//
	MSG(28,12,chr$(DISP_CTRL_CLEARLINE))
	removeKeys():// その待ちの間にタッチキーエリアも解除する
	return(Y)
endfunc

//----------------------------------------------------------------

func GAME()
/* ゲームの実行
	int A
	NM_MARK(PN)
	while YES
		BP=1
		if PN=4 then A=MAN_PLAY() else A=COM_PLAY()
		if A=1 then break
		PNINC()
	endwhile
endfunc

//----------------------------------------------------------------

func PNINC()
/* 次のプレイヤーへの処理
	int I
	for I=1 to BP
		PN=PN+PV
		if PN>4 then PN=PN-5
		if PN<0 then PN=PN+5
		NM_MARK(PN)
		wtm(3)
	next
endfunc

//----------------------------------------------------------------

func MAN_PLAY()
/* プレイヤー(人間)処理
	return(DO_CD(CD_SEL()))
endfunc

//----------------------------------------------------------------

func COM_PLAY()
/* プレイヤー(COMPUTER)処理
	wtm(5)
	return(DO_CD(CD_SELCOM(PN)))
endfunc

//----------------------------------------------------------------

func CD_SELCOM(N)
/* カード選択(コンピューター用)
	int A,B,I
	for I=0 to 3
		A=PL(I+4*PN)
		if BA<90  and YK(A-1) <90  then break
		if BA>=90 and Y_SIM(A)<100 then break
	next
	if I=4 then return(rnd()*4) else return(I)
endfunc

//----------------------------------------------------------------

func DO_CD(N;int)
/* カード操作
	int C
	C=PL(N+4*PN):PL(N+4*PN)=0
	SUTE(C,N)
	YAKU(C)
	if BA<100 then PL(N+4*PN)=DROW(N)
	if BA<100 then return(0) else return(1)
endfunc

//----------------------------------------------------------------

func SUTE(N;int,A;int)
/* カードを場に捨てる
	int  X,Y
	CDPUT(A,PN,0)
	X=rnd()*40+400:Y=rnd()*80+151
	cardPut(X,Y,N,NO)
	a_play(snd_ton)
	C2SET(N)
endfunc

//----------------------------------------------------------------

func C2SET(N;int)
/* 場に捨てたカードの記憶
	int I
	for I=0 to 30
		if C2(I)=9 then break
	next
	C2(1)=N
endfunc

//----------------------------------------------------------------

func BAPLS(N;int)
/* 場の数の加算処理
	N=N mod 13
	if N=0  then N=13
	if N>10 then N=10
	BA=BA+N
	BAPRT()
endfunc

//----------------------------------------------------------------

func DROW(X;int)
/* 新しいカードを引く
	int A,I
	while 1
		for I=0 to 31
			if C1(I)<>0 then {
				A=C1(I):C1(I)=0
				CDPUT(X,PN,A)
				return(A)
			}
		next
		gColor16X68(0):fill(390,141,499,335)
		for I=0 to 31
			C1(I)=C2(I):C2(I)=0
		next
		SFL(32)
	endwhile
endfunc

//----------------------------------------------------------------

func YAKU(N;int)
	int A
	A=Y_TEST(N)
	switch A
		case 1 :BP = 2  :YPRT("==== SKIP ==== ",snd_pico) :break
		case 2 :PV=PV*-1:YPRT("=== REVERCE ===",snd_pico) :break
		case 3 :BA = 99 :YPRT("==== 99 ==== "  ,snd_pico) :break
		case 4 :BA=BA-10:YPRT("==== -10 =====" ,snd_pico) :break
		case 5 :SIMEI() :YPRT(localizedString("==== 指名 ==== ","==== Select ==== "),snd_pico) :break
		case 6 :BA=0    :YPRT(localizedString("==== ゼロ ==== ","==== Zero ==== "),snd_pico) :break
		default:BAPLS(N):YPRT(chr$(DISP_CTRL_CLEARLINE),-1) :break
	endswitch
	BAPRT()
endfunc

//----------------------------------------------------------------

func YPRT(M;str,S;int)
/* 役札の種類の表示
	MSG(30,12,chr$(DISP_CTRL_CLEARLINE)):MSG(30,12,M)
	if S<>-1 then a_play(S)
endfunc

//----------------------------------------------------------------

func BAPRT()
/* 場の数の表示
	if BA<100 then {
		if BA<90 then tColorX68(3) else tColorX68(1)
		MSG(30,9,localizedString("場の数=","Number total=")+right$(" "+str$(BA),2))
		tColorX68(3)
	}
endfunc

//----------------------------------------------------------------

func Y_SIM(N;int)
/* 役札の内容を調べる
	int A
	A=Y_TEST(N)
	N=N mod 13:if N=0 or N>10 then N=10
	switch A
		case 0 :return(BA+N) :break
		case 3 :return(99)   :break
		case 4 :return(BA-10):break
		case 6 :return(0)    :break
		default:return(BA)   :break
	endswitch
endfunc

//----------------------------------------------------------------

func SIMEI()
/* 次のプレイヤーの指名
	int   A,I
	if PN<4 then {
		repeat:A=rnd()*5:until A<>PN
	} else {
		A=PL_SEL()
	}
	BP=0:I=PN
	repeat
		I=I+PV:BP=BP+1
		if I<0 then I=I+5
		if I>4 then I=I-5
	until I=A
endfunc

//----------------------------------------------------------------

func GOVER()
/* ゲームオーバー処理
	int X,Y
	str KY
	cls()
	MSG(36,21, "ＧＡＭＥ　ＯＶＥＲ")
	MSG(36,23, NM(PN)+localizedString("の負けです"," lose."))
	a_play(snd_para)
	for Y=0 to 4
		for X=0 to 3
			CDPUT(X,Y,PL(X+Y*4)+100)
		next
	next
	hitKey(NO)
	BA=0:PV=1
endfunc

//----------------------------------------------------------------

func MSG(X;int,Y;int,M;str)
/* メッセージ表示
	locate(X,Y):print M
endfunc

//----------------------------------------------------------------

func YSETU()
/* 役札説明
	int y=17
	if isLocalizeJapan() then {

		tColorX68(1):MSG(28,y  ,"いつでも使える役札")
		tColorX68(3):MSG(28,y+1," A: (ﾊｰﾄ:場=0 / ﾀﾞｲﾔ:場=99)")
		y=y+2
		tColorX68(1):MSG(28,y  ,"場が90以上で使える役札")
		tColorX68(3)
		MSG(28,y+1,"  A: ﾌﾟﾚｲﾔｰ指名(ﾊｰﾄ/ﾀﾞｲﾔは除く)")
		MSG(28,y+2,"  4: REVERCE")
		MSG(28,y+3,"  9: 場=99" )
		MSG(28,y+4," 10: 場-10")
		MSG(28,y+5,"  J: SKIP")
	} else {
		tColorX68(1):MSG(28,y  ,"Role cards that can be used at any time")
		tColorX68(3):MSG(28,y+1," A: (Heart:Field=0 / Dia:Field=99)")
		y=y+2
		tColorX68(1):MSG(28,y ,"Role cards that can be used at field number is more than 90")
		tColorX68(3)
		MSG(28,y+1,"  A: Select player(Except heart and dia)")
		MSG(28,y+2,"  4: REVERCE")
		MSG(28,y+3,"  9: Field=99" )
		MSG(28,y+4," 10: Field-10")
		MSG(28,y+5,"  J: SKIP")
	}
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
